version: '3.6'

# Persistent volumes (turned of for debugging/demoing purposes)
# volumes:
#   syncotron_data:
#   taskmanager_data:

services:
  # TRACR
  # syncotron services
  syncotron-mysql:
    environment:
      - MYSQL_ROOT_PASSWORD=${mysql_root_password}
      - MYSQL_RANDOM_ROOT_PASSWORD=yes
      - MYSQL_DATABASE=syncotron
      - MYSQL_USER=syncotron
      - MYSQL_PASSWORD=${syncotron_db_password}
    image: mariadb:10.4
    # volumes:
    #   - syncotron_data:/var/lib/mysql
    container_name: syncotron-mysql

  syncotron:
    build: 
      context: ./syncotron
      dockerfile: Dockerfile
    image: bigr/syncotron
    container_name: syncotron
    depends_on:
      - syncotron-mysql
    environment:
      # Setup syncotron
      SYNCO_XNAT_PROJECT: sandbox
      SYNCO_PROJECT_HOME: /project

      # Setup database 
      DB_SCHEMA: 'mysql+pymysql'
      DB_NAME: syncotron
      DB_USER: syncotron
      DB_PASS: ${syncotron_db_password}
      DB_HOST: syncotron-mysql
      DB_PORT: 3306
      
      # jwilder nginx reverse proxy
      # VIRTUAL_HOST: syncotron.bigr.infra
      # VIRTUAL_PORT: 5000
    links:
      - syncotron-mysql:syncotron-mysql
    ports:
      - "5000:5000"
    volumes:
      - $PWD/project-data:/project
      - $PWD/syncotron:/syncotron
      - /var/run/docker.sock:/var/run/docker.sock

  # #Taksmanager services
  taskmanager-mysql:
    environment:
      - MYSQL_ROOT_PASSWORD=${mysql_root_password}
      - MYSQL_DATABASE=taskmanager
      - MYSQL_USER=taskmanager
      - MYSQL_PASSWORD=${taskmanager_db_password}
    image: mariadb:10.4
    # volumes:
    #   - taskmanager_data:/var/lib/mysql
    container_name: taskmanager-mysql

  taskmanager:
    build: 
      context: ./taskmanager
      dockerfile: Dockerfile
    image: bigr/taskmanager
    container_name: taskmanager
    depends_on:
      - taskmanager-mysql
    environment:
      DB_SCHEMA: 'mysql+pymysql'
      DB_NAME: taskmanager
      DB_USER: taskmanager
      DB_PASS: ${taskmanager_db_password}
      DB_HOST: taskmanager-mysql
      DB_PORT: 3306
      # jwilder nginx reverse proxy
      # VIRTUAL_HOST: taskmanager.bigr.infra
      # VIRTUAL_PORT: 5001
    links:
      - taskmanager-mysql:taskmanager-mysql
    ports:
      - "5001:5000"
    volumes:
      - $PWD/project-data/:/project
      - "./project-data/taskmanager_config:/taskmanager_config/:ro"